## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           pngcheck
Version:        4.0.0
Release:        %autorelease
Summary:        Command-line utility to check PNG image files

# Note that the main package contains only pngcheck, compiled from a single
# source file, pngcheck.c, under a minimal MIT-style license that matches SPDX
# HPND:
#   https://gitlab.com/fedora/legal/fedora-license-data/-/issues/85
#   https://tools.spdx.org/app/license_requests/187/
#   https://github.com/spdx/license-list-XML/issues/1725
# The utilities licensed under GPL-2.0-or-later are compiled from the gpl/
# subdirectory and packaged in the extras subpackage.
%global extras_license GPL-2.0-or-later
License:        HPND
SourceLicense:  %{license} AND %{extras_license}
URL:            https://github.com/pnggroup/pngcheck
Source:         %{url}/archive/v%{version}/pngcheck-%{version}.tar.gz

BuildRequires:  dos2unix

BuildRequires:  cmake
BuildRequires:  gcc

BuildRequires:  pkgconfig(zlib)

%description
pngcheck is a command-line utility to check PNG image files, including animated
PNG, for validity and to give information about metadate inside the file (apart
from the actual image data).


%package extras
Summary:        Auxiliary tools distributed with pngcheck
License:        %{extras_license}

# These tools were removed from the pngcheck repository in
# https://github.com/pnggroup/pngcheck/commit/4c888f5d78b51904b160c6b75e3ff7b6a9612aab,
# immmediately after the 4.0.0 release, so we will have to remove this
# subpackage for any future versions.
Provides:       deprecated()

%description extras
This includes:

  - pngsplit - break a PNG, MNG or JNG image into constituent chunks (numbered
    for easy reassembly)
  - png-fix-IDAT-windowsize - fix minor zlib-header breakage caused by libpng
    1.2.6


%prep
%autosetup

dos2unix --keepdate README.md


%build
%cmake -DPNGCHECK_ENABLE_AUX_TOOLS:BOOL=ON
%cmake_build


%install
%cmake_install


# Upstream provides no tests


%files
%license LICENSE
%doc CHANGELOG
%doc README.md
%doc README-303
%{_bindir}/pngcheck
%{_mandir}/man1/pngcheck.1*


%files extras
%license gpl/COPYING
%{_bindir}/pngsplit
%{_bindir}/png-fix-IDAT-windowsize
%{_mandir}/man1/pngsplit.1*
%{_mandir}/man1/png-fix-IDAT-windowsize.1*


%changelog
## START: Generated by rpmautospec
* Thu May 01 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 4.0.0-1
- Update to 4.0.0, with new pnggroup/pngcheck upstream
- Close RHBZ#2363234

* Thu May 01 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.3-9
- Update .rpmlintrc file for current rpmlint

* Fri Dec 13 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.3-8
- Add a SourceLicense field

* Fri Dec 13 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.3-6
- Convert License to SPDX

* Fri Dec 13 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.3-5
- Reduce macro indirection in the spec file

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jul 21 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.3-3
- Drop EPEL-specific workarounds

* Mon Apr 26 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.3-1
- New upstream release 3.0.3 (fixes #1949800)

* Mon Feb 01 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.2-1
- New upstream release 3.0.2

* Sun Jan 31 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.1-1
- New upstream version 3.0.1 with upstreamed patches

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Thu Jan  7 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-4
- Fix buffer overflow on large MNG LOOP chunk (RHBZ#1908559); not built in
  Fedora

* Mon Dec 14 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-3
- Fix a buffer overrun for certain invalid MNG PPLT chunk contents
  (RHBZ#1907428); not built in Fedora

* Mon Dec 14 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-2
- Previous fix for buffer overrun printing the contents of the sPLT chunk in
  certain malformed inputs (RHBZ#1905775) was incomplete; it should be properly
  fixed now.

* Sun Dec 13 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.0-1
- New upstream version 3.0.0 incorporating all patches in 2.4.0-4, and removing
  the -f option

* Sun Dec 13 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.4.0-4
- Bounds-check all accesses into enumerated-value name arrays; a malformed file
  could have caused a buffer overrun in several of these cases. (RHBZ#1902810)
- Fix buffer overrun when print_buffer() is passed a nonpositive size, which
  can occur in practice for certain malformed inputs. (RHBZ#1902810)
- In some cases, the chunk length from the file data (sz) is used to index into
  the read buffer without sufficient bounds-checking, leading to a buffer
  overrun. Fix this for PPLT, hIST, sCAL, FRAM, SAVE, nEED, PAST, DISC, DROP,
  DBYK, ORDR, and SEEK chunks. (RHBZ#1902810)
- Fix buffer overrun printing the contents of the sPLT chunk in certain
  malformed inputs. (RHBZ#1905775)
- Backport fix for off-by-one bug in check_magic() from 3.0.0
- Backport fix for zlib version warnings going to stdout from 3.0.0

* Mon Nov 30 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.4.0-3
- Fix null pointer dereference in pngcheck when -f is given and the sCAL chunk
  is missing the pixel height.
- Use name macro when referencing patches.
- Add BR on make in anticipation of
  https://fedoraproject.org/wiki/Changes/Remove_make_from_BuildRoot.

* Fri Nov 13 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.4.0-2
- Fix buffer overflow (RHBZ #1897485)

* Sun Nov  1 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.4.0-1
- New upstream version 2.4.0
- Added new license file for main package (same MIT-style license)
- Drop format-security patch, now upstreamed
- Use upstreamed man pages; no need to generate with help2man anymore

* Sat Oct 31 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.3.0-5
- Add rpmlintrc rules for -extras subpackage

* Sat Oct 31 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.3.0-4
- Add rpmlintrc file to suppress spurious rpmlint warnings

* Wed Oct 28 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.3.0-3
- Add _hardened_build macro for EPEL

* Wed Oct 28 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.3.0-2
- Work around Makefile.unx not actually using LDFLAGS; this fixes hardened
  build (PIE)

* Thu Oct 15 2020 Benjamin A. Beasley <code@musicinmybrain.net> - 2.3.0-1
- Initial import (#1886858)

## END: Generated by rpmautospec
